        PROGRAM CHIASM


c       laatste verandering: 17-5-2008

        real rhod(600),rhos(600),lhod(600),lhos(600),
     c  od(600),os(600),odos(600),hfod(600),hfos(600)
        character*1 zxcv
        character*30 naam

10      write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) 'CHIASM options:'
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) '      continue                (1)' 
        write(*,*) '      some info and help      (2)' 
        write(*,*) '      exit                    (3)'
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        read(*,'(A)') zxcv
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        if (zxcv.eq.'1') then
          goto 12
        end if
        if ((zxcv.eq.'2').or.(zxcv.eq.'h')) then
          goto 80
        end if
        if ((zxcv.eq.'3').or.(zxcv.eq.'e')) then
          goto 90
        else
          goto 10
        end if

12      write(*,*) ' '
        write(*,*) '      sample frequency (Hz)'
        read(*,*) sf
        if ((sf.ge.100).and.(sf.le.2000)) then
          goto 15
        else
          write(*,*) ' '
          write(*,*) 'sample frequency < 100 Hz or > 2 kHz not allowed'
14        write(*,*) ' '
          write(*,*) '      re-enter sample frequency (1) or exit (2)'
          read (*,'(A)') zxcv
          if (zxcv.eq.'1') then
            goto 12
          end if
          if (zxcv.eq.'2') then
            goto 90
          else
            write(*,*) ' '
            write(*,*) 'input not correct'
            goto 14 
          end if
        end if

c       venster van 60 tot 300 ms
15      n = 0.30*sf
        n60 = nint(0.06*sf)

        write(*,*) ' '
        write(*,*) ' '
        write(*,*) '      **** OD data ****'
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) '      name of datafile'
        read(*,'(A)') naam
16      write(*,*) ' '
        write(*,*) '      row where stimulus was given'
        read(*,*) nnul
        if (nnul.le.0) then
          write(*,*) ' '
          write(*,*) 'row must be at least 1'
          goto 16
        else
          continue
        end if
        neind = nnul+n-1
        open(unit=13,file=naam)
        do 17,i=1,neind,1
          read(unit=13,fmt=*) a,b
          if (i.ge.nnul) then            
            rhod(i-nnul+1) = a
            lhod(i-nnul+1) = b
          end if
17      continue
        close(unit=13)

        write(*,*) ' '
        write(*,*) ' '
        write(*,*) '      **** OS data ****'
        write(*,*) ' '
18      write(*,*) ' '
        write(*,*) '      same (1) or other (2) datafile'
        read(*,'(A)') zxcv
        if (zxcv.eq.'1') then
          goto 20
        end if
        if (zxcv.eq.'2') then
          write(*,*) ' '
          write(*,*) '      name of datafile'
          read(*,'(A)') naam
          goto 20
        else
          write(*,*) ' '
          write(*,*) 'input not correct'
          goto 18
        end if  
20      write(*,*) ' '
        write(*,*) '      row where stimulus was given'
        read(*,*) nnul
        if (nnul.le.0) then
          write(*,*) ' '
          write(*,*) 'row must be at least 1'
          goto 20
        else
          continue
        end if
        neind = nnul+n-1
        open(unit=13,file=naam)
        do 22,i=1,neind,1
          read(unit=13,fmt=*) a,b
          if (i.ge.nnul) then            
            rhos(i-nnul+1) = a
            lhos(i-nnul+1) = b
          end if
22      continue
        close(unit=13)

        do 25,i=1,n,1
          od(i) = rhod(i)-lhod(i)
          os(i) = rhos(i)-lhos(i)
25      continue
        do 27,i=n60,n,1
          avod = 0
          avos = 0
          do 26,j=i-n60+1,i,1
            avod = avod+(od(j)/n60)
            avos = avos+(os(j)/n60)
26          continue
          hfod(i) = od(i)-avod
          hfos(i) = os(i)-avos
          odos(i) = hfod(i)*hfos(i)
27      continue
        som = 0
        abssom = 0
        do 28,i=n60,n,1
          som = som+odos(i)
          abssom = abssom+abs(odos(i))
28      continue
        cc = som/abssom

30      format(A,F5.2)
        write(*,*) ' '
        write(*,*) '---------------------------------'
        write(*,30) ' chiasm coefficient is ',cc
        write(*,*) ' '
        write(*,*) 'for interpretation see Documenta'
        write(*,*) 'Ophthalmologica 2003, 106:137-43'
        write(*,*) '---------------------------------'
        
40      write(*,*) ' '
        write(*,*) '      again (1), new patient (2), or exit (3)'
        read(*,'(A)') zxcv
        if (zxcv.eq.'1') then
          goto 50
        end if
        if (zxcv.eq.'2') then
          goto 15
        end if
        if (zxcv.eq.'3') then
          goto 90 
        else
          write(*,*) ' '
          write(*,*) 'input not correct'
          goto 40
        end if

50      write(*,*) ' '
        write(*,*) ' '
        write(*,*) '      *** OD data ***'
        write(*,*) ' '
55      write(*,*) ' '
        write(*,*) '      same (1) or other (2) datafile'
        read(*,'(A)') zxcv
        if (zxcv.eq.'1') then
          goto 16
        end if
        if (zxcv.eq.'2') then
          write(*,*) ' '
          write(*,*) '      name of datafile'
          read(*,'(A)') naam
          goto 16
        else
          write(*,*) ' '
          write(*,*) 'input not correct'
          goto 55
        end if

80      write(*,*) ' '
        write(*,*) '---------------------------------------------------'
        write(*,*) 'CHIASM  2.6           (c) 1999-2008 Nomdo Jansonius'
        write(*,*) ' '
        write(*,*) 'program to calculate chiasm coefficient cc from VEP'
        write(*,*) ' '
        write(*,*) 'published in: Jansonius et al (2001) A girl without'
        write(*,*) '              a chiasm. J Neuro-Ophthalmol 21:26-29'
        write(*,*) ' '
        write(*,*) 'additional aspects have been presented on the ISCEV'
        write(*,*) 'conferences in Montreal (2001) and in Leuven (2002)'
        write(*,*) ' '
        write(*,*) 'see also: Documenta Ophthalmologica 2003,106:137-43'
        write(*,*) ' '
        write(*,*) 'email: n.m.jansonius@ohk.umcg.nl'
        write(*,*) '---------------------------------------------------'
        write(*,*) 'calculations are performed on ASCII data-files with'
        write(*,*) 'two columns; these columns represent simultaneously' 
        write(*,*) 'recorded signals from the right and left hemisphere'
        write(*,*) '---------------------------------------------------'
        write(*,*) ' '
        write(*,*) '                        press ENTER to continue ...'
        read(*,'(A)') zxcv
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) '---------------------------------------------------'
        write(*,*) 'active electrodes should be positioned at 03 and 04'
        write(*,*) ' '
        write(*,*) 'reference electrode should be at Fz (especially for'
        write(*,*) 'flash VEP, Fp must be avoided)'
        write(*,*) ' '
        write(*,*) 'in young children, flash VEP can be used; for older'
        write(*,*) 'children and adults, pattern onset VEP is preferred'
        write(*,*) ' '
        write(*,*) 'recording has to start at, or before, the stimulus;'
        write(*,*) 'it must continue at least 300 ms after the stimulus' 
        write(*,*) ' '
        write(*,*) 'the stimulus must be administered  monocularly, and'
        write(*,*) 'recordings must be made both during the stimulation'
        write(*,*) 'of OD and during the stimulation of OS'
        write(*,*) ' '
        write(*,*) 'at least two recordings should be performed in both'
        write(*,*) 'eyes; the chiasm coefficient can be calculated four'
        write(*,*) 'times from these recordings (reproducibility check)'
        write(*,*) '---------------------------------------------------'
        write(*,*) ' '
        write(*,*) '                        press ENTER to continue ...'
        read(*,'(A)') zxcv
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) '---------------------------------------------------'
        write(*,*) 'some additional data-file details:'
        write(*,*) ' '
        write(*,*) '1) all filenames must be in 8+3 (16-bit DOS) format'
        write(*,*) ' '
        write(*,*) '2) data-files and program file (chiasm.exe) must be'
        write(*,*) '   in the same directory (or a path must be added)'
        write(*,*) ' '
        write(*,*) '3) in the data-file, empty lines are not allowed in' 
        write(*,*) '   the beginning of the file or in between the rows'
        write(*,*) ' '
        write(*,*) '4) headings above the columns are not allowed; text'
        write(*,*) '   (patient, stimulus and recording information) is'
        write(*,*) '   permitted at the file bottom, below the last row'
        write(*,*) ' '
        write(*,*) '5) all numbers must have decimal point, NOT decimal'
        write(*,*) '   comma (integers are allowed)'
        write(*,*) ' '
        write(*,*) '6) space, tab or comma (csv-format) may be used for'
        write(*,*) '   separation of the columns' 
        write(*,*) '---------------------------------------------------'
        write(*,*) ' '
        write(*,*) '                        press ENTER to continue ...'
        read(*,'(A)') zxcv
        goto 10
   
90      write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) 'CHIASM collapsed to DOS'
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '
        write(*,*) ' '

        end
